function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@dft-vue-2-opentiny/vue-renderless/column-list-item/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@dft-vue-2-opentiny/vue-common";
import Dropdown from "@dft-vue-2-opentiny/vue-dropdown";
import DropdownMenu from "@dft-vue-2-opentiny/vue-dropdown-menu";
import DropdownItem from "@dft-vue-2-opentiny/vue-dropdown-item";
import Checkbox from "@dft-vue-2-opentiny/vue-checkbox";
import { IconEllipsis } from "@dft-vue-2-opentiny/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "block sm:flex w-full p-3 sm:pb-3 text-sm sm:text-xs border-0.5 sm:border rounded-lg sm:rounded border-color-border-separator",
    class: [_vm.state.size === "small" ? "min-h-[4.125rem]" : "min-h-[5.5rem]", _vm.state.effectOptions.length ? "pb-0" : "pb-3"],
    attrs: {
      "role": "column-list-item"
    }
  }, [_vm.state.showCheckbox ? _c("div", {
    staticClass: "float-left sm:float-none mr-3 [&_[data-tag=tiny-checkbox]]:p-0 [&_[data-tag=tiny-checkbox]>span>span]:p-0 [&_[data-tag=tiny-checkbox]>span:nth-child(2)]:hidden"
  }, [_c("tiny-checkbox", {
    attrs: {
      "disabled": _vm.state.disabled,
      "label": _vm.label
    },
    model: {
      value: _vm.state.model,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "model", $$v);
      },
      expression: "state.model"
    }
  })], 1) : _vm._e(), _vm.image || _vm.slots.image && _vm.slots.image() ? _c("div", {
    staticClass: "float-left block sm:flex items-center mr-3 shrink-0",
    class: [_vm.state.size === "small" ? "w-9 h-[2.625rem]" : "w-[3.625rem] h-16"]
  }, [_vm._t("image", [_c("img", {
    staticClass: "rounded",
    class: [_vm.state.size === "small" ? "w-9 h-9" : "w-[3.625rem] h-[3.625rem]"],
    attrs: {
      "src": _vm.image
    }
  })])], 2) : _vm._e(), _c("div", {
    staticClass: "block text-left sm:flex flex-auto flex-wrap",
    class: [_vm.state.size === "small" ? "min-h-[2.625rem]" : "min-h-[4rem]"]
  }, [_vm.slots.column1 && _vm.slots.column1() ? _c("div", {
    staticClass: "min-w-[10rem] overflow-hidden sm:ml-0 pr-0 sm:pr-5",
    style: {
      "flex-grow": _vm.flexGrow[0] || 0,
      "flex-basis": _vm.flexBasis[0] || "auto"
    }
  }, [_vm._t("column1")], 2) : _vm._e(), _vm.slots.column2 && _vm.slots.column2() ? _c("div", {
    staticClass: "min-w-[10rem] overflow-hidden pr-0 sm:pr-5 mt-1 sm:mt-0",
    class: [_vm.state.showCheckbox ? "pl-[1.875rem] sm:pl-0" : ""],
    style: {
      "flex-grow": _vm.flexGrow[1] || 0,
      "flex-basis": _vm.flexBasis[1] || "auto"
    }
  }, [_vm._t("column2")], 2) : _vm._e(), _vm.slots.column3 && _vm.slots.column3() ? _c("div", {
    staticClass: "min-w-[10rem] overflow-hidden pr-0 sm:pr-5 mt-1 sm:mt-0",
    class: [_vm.state.showCheckbox ? "pl-[1.875rem] sm:pl-0" : ""],
    style: {
      "flex-grow": _vm.flexGrow[2] || 0,
      "flex-basis": _vm.flexBasis[2] || "auto"
    }
  }, [_vm._t("column3")], 2) : _vm._e(), _vm.slots.column4 && _vm.slots.column4() ? _c("div", {
    staticClass: "min-w-[10rem] overflow-hidden pr-0 sm:pr-5 mt-1 sm:mt-0",
    class: [_vm.state.showCheckbox ? "pl-[1.875rem] sm:pl-0" : ""],
    style: {
      "flex-grow": _vm.flexGrow[3] || 0,
      "flex-basis": _vm.flexBasis[3] || "auto"
    }
  }, [_vm._t("column4")], 2) : _vm._e()]), _vm.state.effectOptions.length || _vm.slots.operate && _vm.slots.operate() ? _c("hr", {
    staticClass: "block sm:hidden mt-2.5 -mx-3 border-t-0.5 border-t-color-border-separator"
  }) : _vm._e(), _vm.state.effectOptions.length || _vm.slots.operate && _vm.slots.operate() ? _c("div", {
    staticClass: "w-full sm:w-auto px-0 sm:pl-5 sm:pr-2 h-[2.875rem] sm:h-auto flex flex-row sm:flex-col items-center justify-around sm:justify-center sm:items-start shadow-none sm:shadow-[-6px_0px_5px_-5px_#e8ebef] shrink-0 text-color-text-primary"
  }, [_vm._t("operate", [_vm._l(_vm.state.effectOptions.slice(0, _vm.state.sliceNum), function(item, index) {
    return _c("div", {
      key: item.text + index,
      staticClass: "cursor-pointer mb-0 sm:mb-2",
      class: [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
      on: {
        "click": function click($event) {
          return _vm.handelIconClick(item, index);
        }
      }
    }, [_c(item.icon, {
      tag: "component",
      staticClass: "w-4 h-4",
      class: [item.disabled ? "fill-color-icon-disabled" : ""]
    }), item.text ? _c("span", {
      staticClass: "ml-1 align-middle sm:align-bottom"
    }, [_vm._v(_vm._s(item.text))]) : _vm._e()], 1);
  }), _vm.state.effectOptions.length === _vm.state.iconNum ? _c("div", {
    staticClass: "cursor-pointer",
    class: [_vm.state.effectOptions[_vm.state.sliceNum].disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
    on: {
      "click": function click($event) {
        return _vm.handelIconClick(_vm.state.effectOptions[_vm.state.sliceNum], _vm.state.sliceNum);
      }
    }
  }, [_c(_vm.state.effectOptions[_vm.state.sliceNum].icon, {
    tag: "component",
    staticClass: "w-4 h-4",
    class: [_vm.state.effectOptions[_vm.state.sliceNum].disabled ? "fill-color-icon-disabled" : ""]
  }), _vm.state.effectOptions[_vm.state.sliceNum].text ? _c("span", {
    staticClass: "ml-1 align-middle sm:align-bottom"
  }, [_vm._v(_vm._s(_vm.state.effectOptions[_vm.state.sliceNum].text))]) : _vm._e()], 1) : _vm._e(), _vm.state.effectOptions.length > _vm.state.iconNum ? _c("tiny-dropdown", {
    attrs: {
      "show-self-icon": ""
    },
    scopedSlots: _vm._u([{
      key: "dropdown",
      fn: function fn() {
        return [_c("tiny-dropdown-menu", {
          attrs: {
            "placement": "bottom"
          }
        }, _vm._l(_vm.state.effectOptions.slice(_vm.state.sliceNum), function(item, index) {
          return _c("tiny-dropdown-item", {
            key: item.text + index
          }, [_c("div", {
            class: ["px-2", item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""],
            on: {
              "click": function click($event) {
                return _vm.handelIconClick(item, index + _vm.state.sliceNum);
              }
            }
          }, [_c(item.icon, {
            tag: "component",
            staticClass: "w-4 h-4",
            class: [item.disabled ? "fill-color-icon-disabled" : ""]
          }), item.text ? _c("span", [_vm._v(_vm._s(item.text))]) : _vm._e()], 1)]);
        }), 1)];
      },
      proxy: true
    }], null, false, 224789798)
  }, [_c(_vm.iconMore, {
    tag: "component",
    staticClass: "w-4 h-4"
  }), _vm.state.effectOptions[0].text ? _c("span", {
    staticClass: "ml-1 text-color-text-primary"
  }, [_vm._v(_vm._s(_vm.t("ui.base.more")))]) : _vm._e()], 1) : _vm._e()])], 2) : _vm._e()]);
};
var staticRenderFns = [];
var $constants = {
  COLUMN_GROUP: "ColumnListGroup"
};
var __vue2_script = defineComponent({
  name: $prefix + "ColumnListItem",
  emits: ["icon-click", "update:modelValue", "change"],
  components: {
    TinyDropdown: Dropdown,
    TinyDropdownMenu: DropdownMenu,
    TinyDropdownItem: DropdownItem,
    TinyCheckbox: Checkbox,
    IconEllipsis: IconEllipsis()
  },
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    modelValue: {},
    label: {},
    options: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    flexGrow: {
      type: Array,
      default: function _default3() {
        return [1, 1, 1, 1];
      },
      validator: function validator(value) {
        return value.every(function(val) {
          return typeof val === "number" && val >= 0;
        });
      }
    },
    flexBasis: {
      type: Array,
      default: function _default4() {
        return [];
      }
    },
    image: {
      type: String,
      default: ""
    },
    iconMore: {
      type: [Object, String],
      default: function _default5() {
        return IconEllipsis();
      }
    },
    size: {
      type: String,
      default: "medium"
    },
    showCheckbox: {
      type: Boolean,
      default: false
    },
    checkboxDisabled: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var ColumnListItem = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
ColumnListItem.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
ColumnListItem.install = function(Vue) {
  Vue.component(ColumnListItem.name, ColumnListItem);
};
ColumnListItem.version = version;
export {
  ColumnListItem as default
};
